Loading...
Searching...
No Matches
dolfin::MeshHierarchy Class Reference

Experimental implementation of a list of Meshes as a hierarchy. More...

`#include <MeshHierarchy.h>`

## Public Member Functions

| MeshHierarchy ()
| Constructor.
| MeshHierarchy (std::shared_ptr< const Mesh > mesh)
| Constructor with initial mesh.
| ~MeshHierarchy ()
| Destructor.
unsigned int | size () const
| Number of meshes.
std::shared_ptr< const Mesh > | operator[] (int i) const
| Get Mesh i, in range [0:size()] where 0 is the coarsest Mesh.
std::shared_ptr< const Mesh > | finest () const
| Get the finest mesh of the MeshHierarchy.
std::shared_ptr< const Mesh > | coarsest () const
| Get the coarsest mesh of the MeshHierarchy.
std::shared_ptr< const MeshHierarchy > | refine (const MeshFunction< bool > &markers) const
std::shared_ptr< const MeshHierarchy > | unrefine () const
std::shared_ptr< const MeshHierarchy > | coarsen (const MeshFunction< bool > &markers) const
| Coarsen finest mesh by one level, based on markers (level n->n).
std::vector< std::size_t > | weight () const
std::shared_ptr< Mesh > | rebalance () const
| Rebalance across processes.

## Detailed Description

Experimental implementation of a list of Meshes as a hierarchy.

## Member Function Documentation

## refine()

std::shared_ptr< const MeshHierarchy > MeshHierarchy::refine | ( | const MeshFunction< bool > & | markers | ) | const

Refine finest mesh of existing hierarchy, creating a new hierarchy (level n -> n+1)

## unrefine()

std::shared_ptr< const MeshHierarchy > dolfin::MeshHierarchy::unrefine | ( |  | ) | const

inline

Unrefine by returning the previous MeshHierarchy (level n -> n-1) Returns NULL for a MeshHierarchy containing a single Mesh

## weight()

std::vector< std::size_t > MeshHierarchy::weight | ( |  | ) | const

Calculate the number of cells on the finest Mesh which are descendents of each cell on the coarsest Mesh, returning a vector over the cells of the coarsest Mesh.

The documentation for this class was generated from the following files:

- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/MeshHierarchy.h
- /build/dolfin-lFBzDh/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/MeshHierarchy.cpp